/* buildme context */
package buildme

import (
	"errors"
	"os"
	"os/exec"
	"path"

	"dev.hexasoftware.com/hxs/prettylog"
)

var (
	//ErrFetcherNotFound In case fetcher is not found
	ErrFetcherNotFound = errors.New("Fetcher not found")
	log                = prettylog.New("buildme")
)

func TempDir() string {
	tmpDir := path.Join(os.TempDir(), "buildme")
	os.MkdirAll(tmpDir, os.FileMode(0700))

	return tmpDir
}

//BuildMe context
/*type BuildMe struct{}

//New buildme context
func New() *BuildMe {
	return &BuildMe{}
}*/

// Wrong
// Actually load buildme.yml
/*func Prepare(p *Project) {
	var err error
	var thead *tar.Header

	pr := p.Reader()
	defer pr.Close()

	tr := tar.NewReader(pr)
	for {
		thead, err = tr.Next()
		if err != nil {
			break
		}
		if thead.FileInfo().Name() == "buildme.yml" {
			break // found
		}
	}
	if thead == nil {
		return
	}

	data, err := ioutil.ReadAll(tr)

	projConf := ProjectConf{}
	err = yaml.Unmarshal(data, &projConf)
	if err != nil {
		log.Println("Error parsing yaml:", err)
	}
	p.SetConf(projConf)
	//p.Name = projConf.Meta.Project
	log.Println("ProjConf:", projConf)
}*/

//Fetch fetches a Tar file from path/url
func Fetch(ftype string, fpath string) (*Project, error) {
	fetcher, ok := fetchers[ftype]
	if !ok {
		return nil, ErrFetcherNotFound
	}
	log.Println("Fetching:", fpath)

	return fetcher.Fetch(fpath)
}

// Build Fetch url/path and run docker build
///////////////////////////////////////////////////////////////// BUILD
/*func Build(ftype string, fpath string, projName string) error {
	var err error
	// Fetch proj from tar
	proj, err := Fetch(ftype, fpath)
	if err != nil {
		return err
	}
	defer proj.Close()
	Prepare(proj)

	return DockerBuild(proj)
}*/

func mexec(cmdname string, args ...string) {
	cmd := exec.Command(cmdname, args...)
	cmd.Stderr = os.Stderr
	cmd.Stdout = os.Stdout
	cmd.Run()
}
