package main

import (
	"buildme"
	"flag"
	"os"
	"strings"

	_ "buildme/fetcher/git"
	_ "buildme/fetcher/path"

	"dev.hexasoftware.com/hxs/prettylog"
)

var (
	log = prettylog.New("builder")
)

func main() {
	prettylog.Global()

	var fetchType string
	var fetchPath string
	var fetchTask string

	flag.StringVar(&fetchType, "f", "path", "Select fetcher <git,path>")
	flag.Parse()

	if flag.NArg() == 0 {
		fetchPath = "."
	} else {
		fetchPath = flag.Arg(0)
	}

	if flag.NArg() > 1 {
		fetchTask = flag.Arg(1)
	}

	var err error

	log.Println("Testing new build")
	dockerhost := os.Getenv("DOCKER_HOST")
	if dockerhost != "" && !strings.Contains(dockerhost, "://") {
		os.Setenv("DOCKER_HOST", "http://"+dockerhost)
	}

	proj, err := buildme.Fetch(fetchType, fetchPath)
	if err != nil {
		log.Println("Error fetching", err)
		return
	}
	if fetchTask == "" {
		fetchTask = proj.Conf.Default
	}
	log.Println("Executing task:", fetchTask)
	err = proj.Task(fetchTask)
	if err != nil {
		log.Println("Error building", err)
	}
	proj.Close()

	/*err = buildme.Build(fetchType, fetchPath, fetchName)*/

}
