package utils

import (
	"fmt"
	"runtime"
	"strings"
)

func Caller(p ...int) string {
	fns := 2
	if len(p) > 0 {
		fns = p[0]
	}

	fptr, fname, line, ok := runtime.Caller(fns)
	if !ok {
		return ""
	}
	fn := runtime.FuncForPC(fptr)
	return fmt.Sprintf("%s/%s:%d", fname, fn.Name(), line)
}

// Stack Return stack maximum 10
func Stack() string {

	stack := []string{"STACK"}
	for i := 1; i < 10; i++ {
		fptr, _, line, ok := runtime.Caller(i)
		if !ok || i > 10 {
			break
		}
		fn := runtime.FuncForPC(fptr)

		stack = append(stack, fmt.Sprintf("%s:%d", fn.Name(), line))
	}

	return strings.Join(stack, "\n")

}
