package utils

import "io"

type StatReadCloser struct {
	io.ReadCloser
	rd    int
	total int
	fn    func(progress float64)
}

func NewStatReadCloser(rd io.ReadCloser, total int, fn func(progress float64)) *StatReadCloser {
	return &StatReadCloser{rd, 0, total, fn}
}

func (s *StatReadCloser) Read(d []byte) (int, error) {
	n, err := s.ReadCloser.Read(d)
	s.rd += n
	per := float64(s.rd) / float64(s.total) * float64(100)
	s.fn(per)

	return n, err
}
